<img src="https://raw.githubusercontent.com/cyberlabsai/perse-sdk-lite-ios/main/assets/logo_cyberlabs.png" width="300" />

# Perse SDK Lite iOS
From [CyberLabs.AI](https://cyberlabs.ai/).  
_Ready to go biometric verification for the internet._

The Perse CocoaPods SDK Lite:
* Top notch facial detection model;
* Anti-spoofing;
* Feedback on image quality;
* Compare the similarity between two faces;
* Doesn't store any photos;

<img src="https://raw.githubusercontent.com/cyberlabsai/perse-sdk-lite-ios/main/assets/anti_spoof.gif" width="300" />

For more details, you can see the [Official Perse](https://www.getperse.com/).

> #### Soon voice biometric verification.

This SDK provides abstracts the communication with the Perse's API endpoints and also convert the response from json to a pre-defined [responses](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/4.-API#responses).

> #### Want to test the endpoints?
> You can test our endpoints using this [Swagger UI Playground](https://api.getperse.com/swagger/).

> #### Want to test a web live demo?
> You can test our web live demos in the [CyberLabs.AI CodePen](https://codepen.io/cyberlabsai) or in the [Perse Oficial Docs](https://docs.getperse.com/sdk-js/demo.html#authentication-demo
). Do not forget your [API Key](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/2.-API-Key).

> #### Want to try a backend client?
> We have some examples in `Python`, `Go` and `JavaScript`.
> You can see documented [here](https://docs.getperse.com/face-api/#introduction).

## Table of Contents

* [About](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki)
* [Quick Start](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/1.-Quick-Start)
* [API Key](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/2.-API-Key)
* [Usage](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/3.-Usage)
  * [Face Detect](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/3.-Usage#face-detect)
  * [Face Compare](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/3.-Usage#face-compare)
  * [Camera Integration](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/3.-Usage#camera-integration)
* [API](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/4.-API)
  * [Methods](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/4.-API#methods)
  * [Responses](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/4.-API#responses)
  * [Errors](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/4.-API#errors)
* [Demo](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/5.-Demo)
* [API Key](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/4.-API)
* [Tests](https://github.com/cyberlabsai/perse-sdk-lite-ios/wiki/6.-Tests)  
  
## To Contribute and Make It Better

Clone the repo, change what you want and send PR.  
For commit messages we use <a href="https://www.conventionalcommits.org/">Conventional Commits</a>.

Contributions are always welcome!

---

Made with ❤  by the [**Cyberlabs AI**](https://cyberlabs.ai/)
